<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="code" label="CODE">
                <el-input v-model="formData.code" :disabled="'code'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="cityName" label="城市名">
                <el-input v-model="formData.cityName" :disabled="'cityName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="pinYin" label="拼音">
                <el-input v-model="formData.pinYin" :disabled="'pinYin'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark" :disabled="'remark'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="rank" label="排序">
                <el-input type="number" v-model="formData.rank" :disabled="'rank'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="hotFlag" label="热门">
                <el-switch v-model="formData.hotFlag" active-color="#13ce66" inactive-color="#ff4949" :disabled="'hotFlag'==subColumn">
                </el-switch>
            </el-form-item>
            <el-form-item prop="latestTime" label="最近访问时间">
                <template>
                    <div class="block">
                        <el-date-picker v-model="formData.latestTime" type="datetime" value-format="timestamp" placeholder="选择日期" :disabled="'latestTime'==subColumn">
                        </el-date-picker>
                    </div>
                </template>
            </el-form-item>

            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.column) {
            this.subColumn = this.$route.query.column.split(',')[1];
            this.subValue = this.$route.query.column.split(',')[0];
        }

        if (this.$route.query.id) {
            this.$http.get({
                url: '/cityInfo/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {


                    this.formData = res.data;

                    if (this.$route.query.column) {
                        this.formData[this.subColumn] = this.subValue;
                    }

                    this.formData.hotFlag = this.formData.hotFlag == 'Y' ? true : false;
                }
            })
        } else {
            if (this.$route.query.column) {
                this.formData[this.subColumn] = this.subValue;
            }
        }

    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                code:
                    [
                        { required: true, message: '请输入 CODE', trigger: 'blur' },
                    ],
                cityName:
                    [
                        { required: true, message: '请输入 城市名', trigger: 'blur' },
                    ],
            },
            subColumn: '',
            subValue: '',
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));

            data.hotFlag = this.formData.hotFlag ? 'Y' : 'N';

            this.$http.post({
                url: this.formData.id ? '/cityInfo/update' : '/cityInfo/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/cityInfo/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
    }
}
</script>
<style lang="less" scoped>
</style>
